package com.gx.obe.component.text;

import java.math.BigDecimal;

import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.bind.view.ChangeListener;
import com.gx.obe.bind.view.MView;
import com.gx.obe.component.verify.MoneyVerifyListener;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.util.MoneyUtils;

/**
 * @Description: 金额输入框
 * @author chenxw
 */
public class MoneyText extends Text implements MView<BigDecimal> {
	
	private final String unit;
	
	/**
	 * @author chenxw
	 * @param parent
	 * @param style
	 * @param unit
	 */
	public MoneyText(Composite parent, int style, String unit) {
		super(parent, style);
		this.unit = unit;
		addVerifyListener(new MoneyVerifyListener(false, CommonEnum.WAN_YUAN.equals(CommonEnum.getPriceUnitType(unit))));
	}
	
	@Override
	public void set(BigDecimal t) {
		setText(MoneyUtils.getMoneyFormatByUnit(t, unit));
	}
	
	@Override
	public BigDecimal get() {
		return MoneyUtils.getMoneyFromText(getText(), unit);
	}
	
	@Override
	public void addChangeListener(ChangeListener changeListener) {
		addModifyListener(e -> changeListener.change());
	}
	
	@Override
	protected void checkSubclass() {}
	
}