package com.gx.obe.component.text;

import java.math.BigDecimal;
import java.util.Optional;
import java.util.function.UnaryOperator;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.bind.prop.RProp;
import com.gx.obe.bind.view.ChangeListener;
import com.gx.obe.bind.view.RView;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 小写金额文本框
 * @author chenxw
 */
public class OrdinaryMoneyText extends Composite implements RView<UnaryOperator<BigDecimal>> {
	
	/**
	 * @Description: 金额
	 */
	private RProp<BigDecimal> moneyProp = new RProp<BigDecimal>();
	
	/**
	 * @author chenxw
	 * @param parent
	 * @param unit
	 */
	public OrdinaryMoneyText(Composite parent, String unit) {
		super(parent, SWT.NONE);
		setBackground(SWTResourceManager.getColor(239, 243, 248));
		setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginWidth = 35;
		setLayout(gridLayout);
		
		Composite composite = new Composite(this, SWT.NONE);
		GridLayout gl_composite = new GridLayout(3, false);
		gl_composite.verticalSpacing = 10;
		gl_composite.horizontalSpacing = 25;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		
		Label lblNewLabel = new Label(composite, SWT.NONE);
		lblNewLabel.setFont(SWTResourceManager.getFont("微软雅黑", 20, SWT.NORMAL));
		lblNewLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		lblNewLabel.setText("¥");
		
		MoneyText text = new MoneyText(composite, SWT.RIGHT, unit);
		text.setForeground(SWTResourceManager.getColor(204, 204, 204));
		text.setFont(SWTResourceManager.getFont("微软雅黑", 20, SWT.NORMAL));
		text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		moneyProp.reader(text);
		
		Label lblNewLabel_1 = new Label(composite, SWT.NONE);
		lblNewLabel_1.setForeground(SWTResourceManager.getColor(157, 157, 157));
		lblNewLabel_1.setText("万元");
		
		ESepator timeSep = new ESepator(composite, SWT.HORIZONTAL);
		timeSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		timeSep.setBackground(SWTResourceManager.getColor(153, 153, 153));
		timeSep.setLineWidth(3);
	}
	
	@Override
	public UnaryOperator<BigDecimal> get() {
		return t -> Optional.ofNullable(moneyProp.get()).orElse(t);
	}
	
	@Override
	public void addChangeListener(ChangeListener changeListener) {
		moneyProp.addChangeListener(changeListener);
	}
	
	@Override
	protected void checkSubclass() {}
	
}
